#if !defined(AFX_TUBECONTROL_H__F49BF60A_846F_4738_A79E_97FE1188756F__INCLUDED_)
#define AFX_TUBECONTROL_H__F49BF60A_846F_4738_A79E_97FE1188756F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// TubeControl.h : header file
//

#include "DataStructures.h"
#include <vector>

/////////////////////////////////////////////////////////////////////////////
// TubeControl window

class TubeControl : public CStatic
{
// Construction
public:
	TubeControl(const std::vector<Tube>* tube_list);

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(TubeControl)
	public:
	virtual void OnFinalRelease();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~TubeControl();
	void SetSession(const int &session);
	void SetTube(const CString &tube);

  // this callback set up may seem overly complicated, but it does avoid required TubeControl to have knowledge of ProgressDlg
  class ImageSelectCallback
  {
  public:
    ImageSelectCallback() { };
    virtual void SelectImage(const int &tube, const int &session, const int &window) { };
  };

  void SetImageSelectCallback(ImageSelectCallback *callback);

	// Generated message map functions
protected:
	//{{AFX_MSG(TubeControl)
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(TubeControl)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()
private:
	CToolTipCtrl m_tool_tip;
	void GetAt(CPoint point, int *tube, int *window, CRect *rect);
	COLORREF ChooseColor(const int &tube, const int &window);
  void SelectImage(const int &tube, const int &session, const int &window);

  class WindowRect : public CRect
  {
  public:
    int window;

    WindowRect();
    WindowRect(const CPoint &point, const CSize &size, const int &window);
  };
  class TubeRect : public CRect
  {
  public:
    int tube;
    std::vector<WindowRect> windows;

    TubeRect();
    TubeRect(const CPoint &point, const CSize &size, const int &tube);
  };
  
  const std::vector<Tube>* m_tube_list;
  ImageSelectCallback *m_select_image;
  std::vector<TubeRect> m_tubes;
  int m_session;
  CString m_tube;

	CSize m_control_size;
  CSize m_tube_size;
  CSize m_window_size;

	int m_control_margin;
	int m_tube_spacing;
	int m_tube_margin;
  int m_tube_top;
	int m_window_spacing;
  int m_row_length;
  int m_column_length;
  int m_label_height;

	void DrawWindow(const WindowRect &window, const COLORREF &color, CPaintDC *dc);
	void DrawLegend(CPaintDC *dc);

  COLORREF COLOR_NOT_EXIST;
  COLORREF COLOR_NOT_ANNOTATED;
//  COLORREF COLOR_NOT_DONE;
  COLORREF COLOR_DONE;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TUBECONTROL_H__F49BF60A_846F_4738_A79E_97FE1188756F__INCLUDED_)
